<template>
    <div class="order-request-execution">
      <ObForm
        :form-model="formModel"
        :form-data="formData"
        ok-text="Отменить назначение ресурса"
        :is-loading="isLoading"
        data-qa="CancelResursModal"
        @submit="onSubmitHandler"
      >
        <div slot="title" class="ob-ty-modal-title">
          Отмена назначенного ресурса от
          <br/>
          {{ order.executor && order.executor.title }}
        </div>
        <p class="mt20">
          Вы уверены, что вы хотите отменить уже выбранный ресурс этого исполнителя? Это приведет к возможному возникновению претензии.
        </p>
        <div class="title">Отмена назначения</div>
        <div class="checlbox-block">
            <ObCheckbox
              v-for="{ superclass } in requiredResources || []"
              :key="superclass"
              :label="getResourceLabel(superclass)"
              :value="isResource(superclass)"
              :disabled="!isAssignedResource(superclass)"
              @change="onChangeResource(superclass, $event)"
            />
        </div>
        <div class="title">Бумажные документы, связанные с событием</div>
        <ObUploader
          ref="uploader"
          data-qa="uploader"
          @change="onUploadHandler"
        />
      </ObForm>
    </div>
</template>

<script>
import { mapGetters } from 'vuex'
import api from '@/api'
import ObForm from 'common-components/src/obComponents/obForm'
import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
import ObUploader from 'common-components/src/obComponents/obUploader'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import { getResourceClassByCode } from '@/constants/order'
import { required } from 'vuelidate/lib/validators'

export default {
  name: 'CancelResursModal',
  mixins: [
    FormValidationMixin
  ],
  components: {
    ObForm,
    ObCheckbox,
    ObUploader
  },
  props: {
    order: {
      type: Object,
      required: () => {}
    },
    requiredResources: {
      type: Array,
      default: () => []
    },
  },
  data () {
    return {
      isLoading: false
    }
  },
  computed: {
    ...mapGetters({}),
    formModel () {
      return {
        fileUuid: {
          value: ''
        },
        resources: {
          value: [],
          validator: {
            required
          }
        }
      }
    }
  },
  watch: {
    'formData.fileUuid' (value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    },
  },
  methods: {
    async onUploadHandler (data) {
      data = data[0]

      if (!data) {
        this.formData.fileUuid = null
        return
      }

      try {
        await api.files.postFile({ uuid: data.uuid, file: data.file })
        this.formData.fileUuid = data.uuid
      } catch (e) {
        console.log(e)
      }
    },
    async onSubmitHandler (data) {
      this.$emit('on-submitted', data)
    },
    isResource (superclass) {
      return this.formData.resources?.includes(superclass)
    },
    isAssignedResource (superclass) {
      return this.order.resources?.find(item => item.superclass === superclass)
    },
    onChangeResource (superClass, value) {
      let resources = [ ...this.formData.resources ]
      if (value) {
        resources.push(superClass)
      } else {
        resources = resources.filter(item => item !== superClass)
      }

      this.formData.resources = resources
    },
    getResourceLabel (superclass) {
      return getResourceClassByCode(superclass)?.label || 'Неизвестный ресурс'
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .order-request-execution {
    .row {
      margin-top: 20px!important;
      margin-bottom: 20px!important;
    }
    .title {
      margin-top: 30px;
      margin-bottom: 15px;
      @include font-mixin(16px, 24px, 600, $color-text-base , 0.4px);
    }
    .mt20{
      margin-top: 20px;
    }
  }
</style>
